/* Controllers */
peakApp
    .controller('mainCtrl', [
        '$scope',
        function ($scope) {
            console.log("Controller: mainCtrl");
            $scope.isTouchDevice = !!('ontouchstart' in window);
            $scope.isHighDensity = function () {
                return ((window.matchMedia && (window.matchMedia('only screen and (min-resolution: 124dpi), only screen and (min-resolution: 1.3dppx), only screen and (min-resolution: 48.8dpcm)').matches || window.matchMedia('only screen and (-webkit-min-device-pixel-ratio: 1.3), only screen and (-o-min-device-pixel-ratio: 2.6/2), only screen and (min--moz-device-pixel-ratio: 1.3), only screen and (min-device-pixel-ratio: 1.3)').matches)) || (window.devicePixelRatio && window.devicePixelRatio > 1.3));
            };
        }
    ])

    .controller('Login', [
        '$scope',
        '$cookieStore',
        '$location',
        '$state',
        '$http',
        function ($scope, $cookieStore, $location, $state, $http) {
            $scope.$on('$stateChangeSuccess', function () {
                //console.log("Controller: Login");
            });
            
            
            // If the used logged out, mark as logged out.
            $cookieStore.put('authenticated', false);
            $cookieStore.put('authenticatedExpiry', 0)
            
            $scope.LoginAttempt = function (login) {
                $http({
                    method: "put",
                    url: "/api/login",
                    data: login
                })
                .success(function (data) {
                        //console.log('LoginAttempt data=' + data.LoginPassed);
                        if (data.LoginPassed === true) {
                            console.log('Login Authentication Passed');
                            var currentDate = new Date();
                            var expiry = new Date(currentDate.getTime() + 60 * 60 * 1000);// Expiry is one hour
                            //console.log('Current Time=' + currentDate);
                            //console.log('Expiry Time=' + expiry.valueOf());
                            $cookieStore.put('authenticated', true);
                            $cookieStore.put('authenticatedExpiry', expiry.valueOf())
                            $('#IdLoginPassword').val('');
                            $state.go('peak.home');
                        } else {
                            console.log('Login Authentication Failed');
                            $('#IdLoginStatus').html('Authentication Failed');
                            $('#IdLoginPassword').val('');
                            $cookieStore.put('authenticated', false);
                            $cookieStore.put('authenticatedExpiry', 0)
                            setTimeout(function () {
                                $('#IdLoginStatus').html('');
                                $state.go('login');
                            }, 1500);
                        }
                    })
            }
        }
    ])

    .controller('sideMenuCtrl', [
        '$scope',
        '$state',
        '$http',
        '$stateParams',
        '$timeout',
        'socketManager',
        function ($scope, $state, $http, $stateParams, $timeout, socketManager) {
            $scope.sections = [
                {
                    id: 0,
                    title: 'System',
                    icon: 'icon_house first_level_icon',
                    enabled: true,
                    color: "black",
                    link: 'peak.home'
                },
                {
                    id: 1,
                    title: 'Network',
                    icon: 'icon_flowchart_alt first_level_icon',
                    enabled: true,
                    color: "black",
                    link: 'peak.network'
                },
                {
                    id: 2,
                    title: 'Ports',
                    icon: 'icon_adjust-horiz first_level_icon',
                    enabled: true,
                    color: "black",
                    link: 'peak.ports',
                    submenu: [
                        {
                            enabled: false,
                            link: 'peak.port0'
                        },
                        {
                            enabled: false,
                            link: 'peak.port1'
                        },
                        {
                            enabled: false,
                            link: 'peak.port2'
                        },
                        {
                            enabled: false,
                            link: 'peak.port3'
                        }
                    ]
                }
            ];
            
            // accordion menu
            $(document).off('click').on('click', '.side_menu_expanded #main_menu .has_submenu > a', function () {
                var $this_parent = $(this).parent('.has_submenu'),
                    panel_active = $this_parent.hasClass('section_active');
                $('#main_menu .has_submenu').removeClass('section_active').children('ul').slideUp('200');
                if (!panel_active) {
                    $this_parent.addClass('section_active').children('ul').slideDown('200');
                }
            });
            
            $timeout(function () {
                $('#main_menu .has_submenu .act_nav').closest('.has_submenu').children('a').click();
            }, 0);
            
            // Retreive array of Ports
            //  /api/ports
            $scope.GetPorts = function () {
                console.log("Inside sideMenuCtrl.GetPorts")
                $http({
                    method: "get",
                    url: "/api/ports"
                })
                .success(function (data) {
                        console.log('sideMenuCtrl.GetPorts success - data=' + JSON.stringify(data));
                        $scope.PortsArray = data;
                        $scope.PortsCount = data.length;
                        
                        for (var i = 0; i < $scope.PortsCount; i++) {
                            //console.log("DeviceArray[" + i + "].Enabled=" + $scope.PortsArray[i].Enabled)
                            if ($scope.PortsArray[i].Device.localeCompare("NONE")) {
                                $scope.sections[2].submenu[i].enabled = true;
                            } else {
                                $scope.sections[2].submenu[i].enabled = false;                            
                            }
                            $scope.sections[2].submenu[i].title = $scope.PortsArray[i].Name;
                            $scope.sections[2].submenu[i].group = $scope.PortsArray[i].DeviceGroup;
                        }
                    })
            }
            $scope.GetPorts();
            
            // Handle incoming socket.io updates            
            //#region Handle incoming socket.io updates            
            socketManager.on('Ports', function (data) {
                console.log('sideMenuCtrl.socketManager: Ports=' + JSON.stringify(data));
                $scope.PortsArray = data.Ports;
                $scope.PortsCount = data.Ports.length;
                
                for (var i = 0; i < $scope.PortsCount; i++) {
                    //console.log("DeviceArray[" + i + "].Enabled=" + $scope.PortsArray[i].Enabled)
                    if ($scope.PortsArray[i].Device.localeCompare("NONE")) {
                        $scope.sections[2].submenu[i].enabled = true;
                    } else {
                        $scope.sections[2].submenu[i].enabled = false;
                    }
                    $scope.sections[2].submenu[i].title = $scope.PortsArray[i].Name;
                    $scope.sections[2].submenu[i].group = $scope.PortsArray[i].DeviceGroup;
                }
            });
            //#endregion Handle incoming socket.io updates    
        }
    ])

    .controller('Peak', [
        '$scope',
        '$modal',
        '$http',
        '$timeout',
        'socketManager',
        function ($scope, $modal, $http, $timeout, socketManager) {
            //#region Peak - General
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: Peak");
            });
            
            // Retreive the list of available network interfaces
            // Retrieve Eth0 MACID
            //  /api/network/interfaces
            $scope.GetNetworkInterfaces = function () {
                $http({
                    method: "get",
                    url: "/api/network/interfaces"
                })
                .success(function (data) {
                        console.log('Get GetNetworkInterfaces success');
                        // Do something with the data
                        $scope.NetworkInterfaces = data;
                        $scope.NumberOfNetworkInterfaces = $scope.NetworkInterfaces.length
                        
                        $scope.Eth0Macid = "Unavailable - Contact Tech Support";
                        for (i = 0; i < data.length; i++) {
                            if (data[i].Name === "eth0") $scope.Eth0Macid = data[i].MACID;
                        }
                        
                        // Adjust the QR Code
                        $('#IdPeakSerialNumberQrcode').css({ 'width': 50, 'height': 50 }).qrcode({
                            render: 'canvas',
                            size: 100,
                            text: "Peak Serial# " + $scope.Eth0Macid
                        }).children('img').prop('title', $scope.Eth0Macid);
                    })
            }
            $scope.GetNetworkInterfaces();
            
            // Identify the peak using LED blinks
            //  /api/peak/identify
            $scope.IdentifyDevice = function () {
                $http({
                    method: "get",
                    url: "/api/peak/identify"
                }).success(function (data) {
                        console.log('IdentifyDevice success');
                    });
                //$event.preventDefault();
            }
            //#endregion Peak - General
            
            //#region Crest - Operations
            //----------------------------------------------------------
            // Crest operations
            
            // Get Crest info
            //  /api/crest
            $scope.GetAppInfo = function () {
                $http({
                    method: "get",
                    url: "/api/crest"
                })
                .success(function (data) {
                        console.log('Get GetAppInfo success');
                        $('#IdCurrentAppInfo').html("Installed: " + data.description + " v" + data.version);
                        $scope.InstalledPackage = data;
                    })
            }
            $scope.GetAppInfo();
            
            $scope.UpgradeAvailable = true;// Always allow users to Manage versions
            // Retreive the latest Crest version
            //  /api/crest/latest
            $scope.GetLatestVersion = function () {
                $scope.WaitingForLatestVersionInfo = true;
                $timeout(function () {
                    $('#IdLatestVersion').css('color', 'red');
                    $('#IdLatestVersion').html("Retrieving version info from server ... please wait.");
                })
                $http({
                    method: "get",
                    url: "/api/crest/latest"
                })
                .success(function (version) {
                        console.log('GetLatestVersion result=' + version);
                        $scope.WaitingForLatestVersionInfo = false;
                        
                        if (version.indexOf("Error") == 0) {
                            $timeout(function () {
                                $('#IdLatestVersion').css('color', 'red');
                                $('#IdLatestVersion').html(version);
                                $scope.LatestVersion = version;
                            })
                        } else {
                            $timeout(function () {
                                $('#IdLatestVersion').css('color', 'black');
                                $('#IdLatestVersion').html("Latest Available: " + $scope.InstalledPackage.description + " v" + version);
                                $scope.LatestVersion = version;
                                if ($scope.LatestVersion !== $scope.InstalledPackage.version) {
                                    $scope.UpgradeAvailable = true;
                                }
                            })
                        }
                    })
            }
            $scope.GetLatestVersion();
            //#endregion Crest
            
            //#region Peak - System Information tab
            //----------------------------------------------------------
            // System Information tab
            
            // Retreive the OS information
            //  /api/peak/operatingsystem
            $scope.GetOsInfo = function () {
                $http({
                    method: "get",
                    url: "/api/peak/operatingsystem"
                })
                .success(function (data) {
                        console.log('Get GetOsInfo success');
                        $('#IdCurrentOsInfo').html(data.os);
                        $scope.OsVersion = data;
                    })
            }
            $scope.GetOsInfo();
            
            // Get Crest software
            //  /api/crest/download
            $scope.GetCrestSoftware = function (installedProduct, latestVersion) {
                console.log("Inside GetCrestSoftware")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/GetCrestSoftware.html',
                    controller: function ($scope, $modalInstance) {
                        // Setup the Get Crest Software modal
                        //#region GetCrestSoftwareUpdate controller preamble
                        $scope.modalTitle = "Get Crest Software";
                        $scope.DownloadFromTasc = true;
                        $scope.LatestVersion = latestVersion;
                        $scope.InstalledProduct = installedProduct;
                        $scope.CrestUrl = 'http://www.tascsystems.com/downloads/peak/crest-v' + latestVersion + '.tar';
                        $scope.CustomUrl = 'http://www.tascsystems.com/downloads/peak/crest-v' + latestVersion + '.tar';
                        $scope.CustomUrlPattern = /^https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)?$/;
                        $scope.DownloadInProgress = false;
                        //#endregion SetNetworkInterface controller preamble
                        
                        //  Download Crest software
                        //# region Download Crest software
                        $scope.Apply = function (DownloadFromTasc, CustomUrl) {
                            
                            // Initiate the download operation
                            $scope.DownloadInProgress = true;
                            $scope.ErrorInDownload = false;
                            $scope.DownloadComplete = false;
                            $scope.CrestUrl = 'http://www.tascsystems.com/downloads/peak/crest-v' + latestVersion + '.tar';
                            if (!DownloadFromTasc) $scope.CrestUrl = encodeURI(CustomUrl);// Encode to ensure that we handle custom URIs
                            console.log('GetCrestSoftware: "' + $scope.CrestUrl + '"');
                            
                            $http({
                                method: "put",
                                url: "/api/crest/download",
                                data: { CrestUrl: $scope.CrestUrl }
                            })
                            .success(function (result) {
                                    console.log('GetCrestSoftware: "' + $scope.CrestUrl + '" result=' + result);
                                    
                                    if (result.indexOf("Error") != 0) {
                                        // Show as downloaded and available on next reboot
                                        $scope.DownloadInProgress = false;
                                        $scope.DownloadComplete = true;
                                        $scope.ErrorInDownload = false;                                        
                                    } else {
                                        $scope.DownloadInProgress = false;
                                        $scope.ErrorInDownload = true;
                                    }
                                })
                        };
                        //# endregion Download Crest software
                        
                        $scope.Complete = function () {
                            // Exit - this button only available after download is complete
                            $modalInstance.close();                        
                        }
                        
                        //  User canceled operation
                        $scope.Cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            
            // Get system status
            //  /api/peak/systemstatus
            $scope.GetSystemStatus = function () {
                $http({
                    method: "get",
                    url: "/api/peak/systemstatus"
                })
                .success(function (data) {
                        console.log('Get GetSystemEvents data="' + data + '"');
                        $('#IdCurrentSystemStatus').html(data);
                        switch (data) {
                            case "NORMAL":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                                break;
                            case "WARNING":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                                break;
                            case "FAILURE":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                break;
                            default:
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                $('#IdCurrentSystemStatus').html("UNKNOWN");
                                break;
                        }
                    })
            }
            $scope.GetSystemStatus();
            
            // Retreive the list of available network interfaces
            //  /api/network/interfaces
            $scope.GetNetworkInterfaces = function () {
                $http({
                    method: "get",
                    url: "/api/network/interfaces"
                })
                .success(function (data) {
                        console.log('Get GetNetworkInterfaces success');
                        // Do something with the data
                        $scope.NetworkInterfaces = data;
                        $scope.NumberOfNetworkInterfaces = $scope.NetworkInterfaces.length
                    })
            }
            $scope.GetNetworkInterfaces();
            
            // Footable
            $('#IdPeakTable').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            }).on({
                    'footable_filtering': function (e) {
                        var selected = $scope.userStatus;
                        if (selected && selected.length > 0) {
                            e.filter += (e.filter && e.filter.length > 0) ? ' ' + selected : selected;
                            e.clear = !e.filter;
                        }
                    }
                });
            
            $scope.clearFilters = function () {
                $('.filter-status').val('');
                $('#footable_peak').trigger('footable_clear_filter');
            };
            
            $scope.filterTable = function (userStatus) {
                $('#footable_peak').data('footable-filter').filter($('#textFilter').val());
            };
            
            // socket.io
            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });
            
            // Handle incoming socket.io updates            
            socketManager.on('CurrentSystemTime', function (message) {
                $scope.CurrentSystemTime = message.CurrentSystemTime;
            });
            
            socketManager.on('SystemStatus', function (message) {
                $('#IdCurrentSystemStatus').html(message.ErrorType);
                switch (message) {
                    case "NORMAL":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                        break;
                    case "WARNING":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                        break;
                    case "FAILURE":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        break;
                    default:
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        $('#IdCurrentSystemStatus').html("UNKNOWN");
                        break;
                }
            });
            
            // Handle incoming socket.io updates            
            socketManager.on('PeakLocation', function (message) {
                $scope.peak = new google.maps.LatLng(message.latitude, message.longitude);
                $scope.PeakLatitude = $scope.peak.lat().toFixed(4);
                $scope.PeakLongitude = $scope.peak.lng().toFixed(4);
                console.log("Controller: gpsCtrl - latitude=" + $scope.PeakLatitude + " longitude=" + $scope.PeakLongitude);
                
                $('#IdGpsLocation').html("Latitude=" + $scope.PeakLatitude + "<br/>" + "Longitude=" + $scope.PeakLongitude);
            });
            
            //#endregion Peak - System Information tab
            
            //#region Get Ports, Devices and DeviceGroups
            
            // Retreive PortsArray
            //  /api/ports
            $scope.Ports = [];
            $scope.PortsCount = 0;
            $scope.PortsAllocated = 0;
            $scope.GetPorts = function () {
                console.log("Inside ports.GetPorts")
                $http({
                    method: "get",
                    url: "/api/ports"
                })
                .success(function (data) {
                        console.log('ports.GetPorts success - data=' + JSON.stringify(data));
                        $scope.Ports = data;
                        $scope.PortsCount = data.length;
                        
                        $scope.PortsAllocated = 0;
                        for (i = 0; i < $scope.PortsCount; i++) {
                            if (data[i].Device.localeCompare("NONE")) {
                                $scope.PortsAllocated++;
                            }
                        }
                    })
            }
            $scope.GetPorts();
            
            // Retreive Devices
            //  /api/devices
            $scope.Devices = [];
            $scope.DevicesCount = 0;
            $scope.GetDevices = function () {
                console.log("Inside ports.GetDevices")
                $http({
                    method: "get",
                    url: "/api/devices"
                })
                .success(function (data) {
                        console.log('ports.GetDevices success - data=' + JSON.stringify(data));
                        $scope.Devices = data;
                        $scope.DevicesCount = data.length;
                    })
            }
            $scope.GetDevices();
            
            // Retreive DeviceGroupsListArray
            //  /api/devicegroups
            $scope.DeviceGroups = [];
            $scope.DeviceGroupsCount = 0;
            $scope.GetDeviceGroups = function () {
                console.log("Inside ports.GetDeviceGroups")
                $http({
                    method: "get",
                    url: "/api/devicegroups"
                })
                .success(function (data) {
                        console.log('ports.GetDeviceGroups success - data=' + JSON.stringify(data));
                        $scope.DeviceGroups = data;
                        $scope.DeviceGroupsCount = data.length;
                    })
            }
            $scope.GetDeviceGroups();
            //#endregion Get Ports, Devices and DeviceGroups
            
            //#region Peak - Users tab
            
            // Retreive the Peak Users
            //  /api/login/users
            $scope.GetPeakUser = function () {
                console.log("Inside GetPeakUser ...")
                $http({
                    method: "get",
                    url: "/api/login/users"
                })
                .success(function (data) {
                        console.log('Get GetPeakUser success');
                        // Do something with the data
                        $scope.PeakUser = data;
                    })
            }
            $scope.GetPeakUser();// Go get Log Files
            
            // Retreive Peak Login Attempts
            //  /api/login/attempts
            $scope.GetPeakLoginAttempts = function () {
                console.log("Inside GetPeakLoginAttempts ...")
                $http({
                    method: "get",
                    url: "/api/login/attempts"
                })
                .success(function (data) {
                        console.log('Get GetPeakLoginAttempts success');
                        // Do something with the data
                        $scope.PeakLoginAttempts = data;
                    })
            }
            $scope.GetPeakLoginAttempts();// Go get Log Files
            
            // Change User Credentials
            //  /api/login/user
            $scope.ConfigureUserCredentials = function (user) {
                console.log("Inside ConfigureUserCredentials")
                
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageUserCredentials.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Change User Credentials";
                        $scope.TypeOfView = "password";
                        
                        // Make a copy of original credentials, for back up
                        $scope.temp = {
                            "user": user.user,
                            "password": user.password,
                            "confirm": user.password
                        };
                        
                        // Username pattern
                        //  1. 4-32 characters
                        //  2. Alphanumeric characters only
                        $scope.UserPattern = /^[\w]{4,32}$/;
                        // Password pattern
                        //  1. 4-32 characters
                        //  2. The following special chars are allowed (0 or more): !@#$%
                        //  3. Alphanumeric characters are also allowed
                        $scope.PasswordPattern = /^[0-9a-zA-Z!@#$%]{4,32}$/;
                        
                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/login/user");
                            
                            $http({
                                method: "put",
                                url: "/api/login/users",
                                data: $scope.temp
                            }).success(function (data) {
                                    console.log('ConfigureUserCredentials PUT success data=' + JSON.stringify(data));
                                    user.user = data.user;
                                    user.password = data.password;
                                    user.lastlogin = data.lastlogin;
                                });
                            $modalInstance.close($scope.temp);
                        };
                        
                        // Toggle
                        
                        $scope.ShowPasswordToggle = function () {
                            if ($scope.TypeOfView === "password") {
                                $scope.TypeOfView = "text";
                            } else {
                                $scope.TypeOfView = "password";
                            }
                        }
                        
                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
                
                modalInstance.result.then(function (peakUser) {
                    // Modal close
                }, function () {
                    // Dismissed
                });
            };
            
            //#endregion Peak - Users tab

            //#region Peak - Logging tab
            //----------------------------------------------------------
            // Logging tab
            
            $scope.LoggingVerbosity
            $scope.LoggingVerbosityOpposite
            
            // Retreive the system software information
            //  /api/logging/loglevel
            $scope.GetLoggingVerbosity = function () {
                $http({
                    method: "get",
                    url: "/api/logging/loglevel"
                })
                .success(function (data) {
                        console.log('Get GetLoggingVerbosity success - data=' + data.LogLevel);
                        $scope.LoggingVerbosity = data.LogLevel;
                        if ($scope.LoggingVerbosity == "BASIC")
                            $scope.LoggingVerbosityOpposite = "VERBOSE"
                        else
                            $scope.LoggingVerbosityOpposite = "BASIC"
                        $('#IdLoggingVerbosity').html($scope.LoggingVerbosity);
                        $('#IdLoggingVerbosityOpposite').html($scope.LoggingVerbosityOpposite);
                    })
            }
            $scope.GetLoggingVerbosity();
            
            $scope.LoggingVerbosityChange = function () {
                if ($scope.LoggingVerbosity === "BASIC")
                    changeURL = "/api/logging/loglevel/VERBOSE"
                else
                    changeURL = "/api/logging/loglevel/BASIC"
                console.log("PUT to " + changeURL);
                
                $http({
                    method: "put",
                    url: changeURL
                })
                    .success(function (data) {
                        console.log('Put LoggingVerbosityChange success - data=' + data.LogLevel);
                        $scope.LoggingVerbosity = data.LogLevel;
                        if ($scope.LoggingVerbosity == "BASIC")
                            $scope.LoggingVerbosityOpposite = "VERBOSE"
                        else
                            $scope.LoggingVerbosityOpposite = "BASIC"
                        $('#IdLoggingVerbosity').html($scope.LoggingVerbosity);
                        $('#IdLoggingVerbosityOpposite').html($scope.LoggingVerbosityOpposite);
                    })
            }
            
            // Retreive the log files
            //  /api/logging/logfiles
            $scope.GetLogFiles = function () {
                $http({
                    method: "get",
                    url: "/api/logging/logfiles"
                })
                .success(function (data) {
                        console.log('Get GetLogFiles success');
                        // Do something with the data
                        $scope.LogFiles = data;
                        $scope.NumberOfLogFiles = $scope.LogFiles.length
                    })
            }
            $scope.GetLogFiles();// Go get Log Files
            
            // View a log file
            //  /api/logging/logfiles/:logfile
            $scope.DisplayLogFile = function (logFile) {
                console.log("Inside DisplayLogFile")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/displaylogfile.html',
                    size : 'lg',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = logFile;
                        
                        // Go get the log file
                        console.log("Inside DisplayLogFile: '/api/logging/logfiles/" + logFile + "'");
                        $http({
                            method: 'GET',
                            url: "/api/logging/logfiles/" + logFile
                        }).success(function (data) {
                                console.log("Get logging/logfiles/" + logFile + " success");
                                $('#IdLogFileContents').html(decodeURIComponent(data));
                                $('#IdLogFileContents').css('font-size', 'smaller');
                            });
                        
                        // Done viewing
                        $scope.done = function () {
                            $modalInstance.dismiss('done');
                        };
                        
                        // Cancel (x) press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            
            // Download a log file
            $scope.DownloadLogFile = function (logFile) {
                console.log("Inside DownloadLogFile: '/api/logging/logfiles/" + logFile + "'");
                $http({
                    method: 'GET',
                    url: "/api/logging/logfiles/" + logFile
                }).
                success(function (data, status, headers, config) {
                        console.log("Inside DownloadLogFile - received data!");
                        var anchor = angular.element('<a/>');
                        anchor.attr({
                            href: 'data:text/plain;charset=utf-8,' + data,
                            target: '_blank',
                            download: logFile
                        })[0].click();

                    }).
                error(function (data, status, headers, config) {
                        console.log("Error downloading log file")
                    });
            };
            //#endregion Peak - Logging tab           
        }
    ])

    .controller('systemStatus', [
        '$scope',
        '$http',
        'socketManager',
        function ($scope, $http, socketManager) {
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: systemStatus");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            // Retreive System Status array through RESTful API
            $scope.GetSystemStatus = function () {
                $http({
                    method: "get",
                    url: "/api/systemstatus"
                })
                    .success(function (data) {
                        console.log('GetSystemStatus data=' + data);
                        $scope.SystemStatus = data;
                        $scope.SystemStatusTotal = data.length;
                    })
            }
            $scope.GetSystemStatus();// Go get System System

            // Retreive the Current System Status through RESTful API
            $scope.GetCurrentSystemStatus = function () {
                $http({
                    method: "get",
                    url: "/api/currentsystemstatus"
                })
                    .success(function (data) {
                        console.log('Get GetCurrentSystemStatus data="' + data + '"');
                        $('#IdCurrentSystemStatus').html(data);
                        switch (data) {
                            case "NORMAL":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                                break;
                            case "WARNING":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                                break;
                            case "FAILURE":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                break;
                            default:
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                $('#IdCurrentSystemStatus').html("UNKNOWN");
                                break;
                        }
                    })
            }
            $scope.GetCurrentSystemStatus();// Go get Current System Status

            $scope.CauseError = function () {
                $http({
                    method: "get",
                    url: "/api/causeerror"
                })
                    .success(function (data) {
                        console.log('Get CauseError data="' + data + '"');
                    })
            }

            socketManager.on('SystemStatus', function (message) {
                $('#IdCurrentSystemStatus').html(message.ErrorType);
                switch (data) {
                    case "NORMAL":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                        break;
                    case "WARNING":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                        break;
                    case "FAILURE":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        break;
                    default:
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        $('#IdCurrentSystemStatus').html("UNKNOWN");
                        break;
                }
            });
        }
    ])

     .controller('networkCtrl', [
        '$scope',
        '$modal',
        '$http',
        '$timeout',
        'socketManager',
        function ($scope, $modal, $http, $timeout, socketManager) {
            
            //#region Network - General
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: networkCtrl");
            });
            
            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });
            //#endregion Network - General
            
            //----------------------------------------------------------
            // Network - Interfaces tab
            //#region Network - Interfaces tab
            
            $('#IdNetworkTable').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
            
            // Retreive the list of available network interfaces
            //  /api/network/interfaces
            $scope.GetNetworkInterfaces = function () {
                console.log("GetNetworkInterfaces called ...")
                $scope.WaitingForNetworkInfo = true;
                $http({
                    method: "get",
                    url: "/api/network/interfaces"
                })
                .success(function (data) {
                        console.log('Get GetNetworkInterfaces success - data=' + JSON.stringify(data));
                        // Do something with the data
                        $scope.NetworkInterfaces = data;
                        $scope.NumberOfNetworkInterfaces = $scope.NetworkInterfaces.length
                        $scope.WaitingForNetworkInfo = false;
                    })
            }
            $scope.GetNetworkInterfaces();
            
            // Set the network interface
            //  /api/network/interfaces/:interface
            $scope.SetNetworkInterface = function (networkInterface) {
                console.log("Inside SetNetworkInterface for interface=" + JSON.stringify(networkInterface))
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/SetNetworkInterface.html',
                    controller: function ($scope, $modalInstance) {
                        //#region SetNetworkInterface controller preamble
                        // Clone a copy of the Interface for temporary use and sending to API
                        //  We'll copy back the reply to the Interface object if successful
                        $scope.TempInterface = JSON.parse(JSON.stringify(networkInterface));
                        
                        // Modal options
                        $scope.modalTitle = "Configure " + $scope.TempInterface.Name;
                        $scope.MethodOptions = [{ type: "DHCP" }, { type: "STATIC" }];
                        if ($scope.TempInterface.Method === "STATIC") {
                            $scope.StaticIP = true
                        }
                        else {
                            $scope.StaticIP = false;
                        }
                        
                        // Handle toggles of Method type
                        $scope.MethodSelected = function (method) {
                            console.log("Selected Assignment=" + method)
                            $scope.TempInterface.Method = method;
                            if (method === "STATIC") {
                                $scope.StaticIP = true
                            }
                            else {
                                $scope.StaticIP = false;
                            }
                        }
                        $scope.IPAddressFilter = /^(([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.){3}([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
                        $scope.NetmaskFilter = /^([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.((\d|\d\d|1\d\d|2[0-4]\d|25[0-5])\.){2}(\d|[1-9]\d|1\d\d|2[0-4]|25[0-5]\d)$/;
                        $scope.GatewayFilter = /^(([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.){3}([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
                        //#endregion SetNetworkInterface controller preamble
                        
                        //  Show users the changes and prepare for reboot
                        //# region ApplyNetworkInterface function
                        $scope.ApplyNetworkInterface = function () {
                            
                            // We need to reboot, so let user confirm
                            //# region ConfirmReboot function
                            $scope.ConfirmReboot = function (ifaceNew) {
                                console.log('   Confirm Reboot modal started!')
                                var $modalInstance = $modal.open({
                                    templateUrl: 'views/partials/NetworkInterfaceChanged.html',
                                    size: '',
                                    controller: function ($scope, $modalInstance) {
                                        
                                        // There were some changes, so let's bringup the modal
                                        $scope.modalTitle = 'Network Interface has changed!';
                                        if (ifaceNew.Method === 'DHCP') {
                                            $scope.NewInterfaceSettings = '<p>' + ifaceNew.Name + ' has been changed to:</p><p>&nbsp;&nbsp;Method: DHCP</p>';
                                        } else {
                                            $scope.NewInterfaceSettings = '<p>' + ifaceNew.Name + ' has been changed to:</p><p>&nbsp;&nbsp;Method: STATIC</p><p>&nbsp;&nbsp;IP Address: ' + ifaceNew.IPAddress + '</p><p>&nbsp;&nbsp;Netmask: ' + ifaceNew.Netmask + '</p><p>&nbsp;&nbsp;Gateway: ' + ifaceNew.Gateway + '</p>';
                                        }
                                        
                                        $scope.ok = function () {
                                            $modalInstance.close();
                                        };
                                    }
                                });
                            }
                            
                            var NetworkInterfaceChanged = false;
                            
                            console.log('Comparison of new settings vs. old:');
                            console.log('New=' + JSON.stringify($scope.TempInterface));
                            console.log('Old=' + JSON.stringify(networkInterface));
                            
                            if ($scope.TempInterface.Method == networkInterface.Method) {
                                // Check to see if anything has changed
                                
                                // DHCP -> DHCP - no change
                                if ($scope.TempInterface.Method === 'DHCP') {
                                    //  we don't need to throw up this modal, cuz nothing really changed 
                                    NetworkInterfaceChanged = false;
                                    console.log('   DHCP->DHCP no change, so exit');

                                } 
                                
                                // STATIC -> STATIC (with no parameter changes)
                                else if (JSON.stringify($scope.TempInterface) == JSON.stringify(networkInterface)) {
                                    // If we're going from Static -> Static and nothing changed, 
                                    //  we don't need to throw up this modal, cuz nothing really changed 
                                    NetworkInterfaceChanged = false;
                                    console.log('   STATIC->STATIC no change, so exit');
                                } 
                                
                                // STATIC -> STATIC (with parameter changes)
                                else {
                                    // If we're going from Static -> Static and nothing changed, 
                                    //  we don't need to throw up this modal, cuz nothing really changed 
                                    NetworkInterfaceChanged = true;
                                    console.log('   STATIC->STATIC with change, do change');
                                }
                            } 
                            
                            else {
                                // If we're going from Static -> DHCP or DHCP -> STATIC, 
                                NetworkInterfaceChanged = true;
                                console.log('   DHCP->STATIC or STATIC->DHCP, do change');
                            }
                            
                            // If we see that network interfaces have changed, then bring up another dialog box
                            if (NetworkInterfaceChanged) {
                                // Send out the changed network interface
                                console.log("Sending: '/api/network/interfaces'" + $scope.TempInterface.Name);
                                console.log("  NetworkInterface.IPAddress=" + $scope.TempInterface.IPAddress);
                                $http({
                                    method: 'PUT',
                                    url: "/api/network/interfaces",
                                    data: $scope.TempInterface
                                }).success(function (data) {
                                    console.log('/api/network/interfaces PUT success data=' + JSON.stringify(data));
                                    networkInterface = data;
                                    // Confirm the reboot now that network changes are in place
                                    $scope.ConfirmReboot($scope.TempInterface);
                                    $modalInstance.close();
                                });
                            } else {
                                $modalInstance.close();
                            }
                            //# region ConfirmReboot function
                            
                        };
                        //# endregion ApplyNetworkInterface function
                        
                        //  User canceled operation
                        $scope.CancelNetworkInterface = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Network - Interfaces tab
            
            //----------------------------------------------------------
            // Email (SMTP)
            //#region Network - Email (SMTP)
            
            $scope.SmtpSettings = [];// Holds SMTP Settings

            // Retreive SMTP Host info
            //  /api/network/smtp
            $scope.GetSmtpHosts = function () {
                console.log("GetSmtpHosts called ...")
                $http({
                    method: "get",
                    url: "/api/network/smtp"
                })
                .success(function (data) {
                        console.log('GetSmtpHosts success - data=' + JSON.stringify(data));
                        $scope.HostName = data.HostName;
                        $scope.SmtpSettings = data;
                    })
            }
            $scope.GetSmtpHosts();
            
            //#region archive
            //$scope.SmtpHost = {
            //    HostName: "MyGmail",
            //    Enabled: "TRUE",
            //    IPAddress: "smtp.gmail.com",
            //    Port: 465,
            //    FromEmail: "tascsystems@gmail.com",
            //    Authorization: {
            //        User: "tascsystems@gmail.com",
            //        Pass: "TotallyAwesome!"
            //    },
            //    Secure: true
            //}
            
            //$scope.SmtpToEmailList = [{
            //        Name: "TechSupport",
            //        Enabled: "TRUE",
            //        EmailAddress: "support@tascsystems.com"
            //    },
            //    {
            //        Name: "Info",
            //        Enabled: "FALSE",
            //        EmailAddress: "info@tascsystems.com"
            //    },
            //];
            //#endregion archive
            
            // Send test email to SMTP server
            //  /api/network/smtp/test
            $scope.TestSmtpHost = function () {
                console.log("Inside TestSmtpHost");
                $scope.SmtpTest = "Testing";
                
                var ToList = "";
                var AddedEmail = false;
                //for (var e = 0; e < $scope.SmtpSettings.Options.To.length; e++) {
                //    if ($scope.SmtpSettings.Options.To[e].Enabled) {
                //        console.log("TestSmtpHost: Adding email=" + $scope.SmtpSettings.Options.To[e].Email);
                //        if (AddedEmail) ToList += ",";// Add separator if we previously had an email
                //        ToList += $scope.SmtpSettings.Options.To[e].Email;
                //        AddedEmail = true;  
                //    }
                //}
                ToList = $scope.SmtpSettings.Options.From;
                console.log("TestSmtpHost: ToList=" + ToList);                
                
                var data = {
                    Port: $scope.SmtpSettings.Transport.Port,
                    Host: $scope.SmtpSettings.Transport.Host,
                    Secure: $scope.SmtpSettings.Transport.Secure,
                    User: $scope.SmtpSettings.Transport.Auth.User,
                    Pass: $scope.SmtpSettings.Transport.Auth.Pass,
                    From: $scope.SmtpSettings.Options.From,
                    To: ToList
                }
                
                $http({
                    method: "put",
                    url: "/api/network/smtp/test",
                    data: data
                })
                .success(function (data) {
                        console.log('TestSmtpHost success - data=' + JSON.stringify(data));
                        if (data.result) {
                            $scope.SmtpTest = "Success";// This is to show the succeeded symbol
                        }
                        else {
                            $scope.SmtpTest = "Failed";// This is to show the fail symbol

                            // Throw up a message to let user know the error that was received
                            var modalInstance = $modal.open({
                                templateUrl: 'views/partials/SmtpErrorModal.html',
                                controller: function ($scope, $modalInstance) {
                                    $scope.modalTitle = 'SMTP Test Error';
                                    $scope.modalCode = "Error Type: " + data.response.code + "  (Code=" + data.response.responseCode + ")";
                                    $scope.modalResponse = data.response.response
                                    
                                    $scope.ok = function () {
                                        $modalInstance.close();
                                    };
                                    
                                    $scope.cancel = function () {
                                        $modalInstance.dismiss('cancel');
                                    };

                                }
                            });
                        }
                        // Clear image
                        $timeout(function () {$scope.SmtpTest = "";}, 3000);
                    })
            };
            
            // Configure SMTP Settings 
            //  /api/network/smtp
            $scope.ConfigureSmtpSettings = function (SmtpSettings) {
                console.log("Inside ConfigureSmtpSettings")
                var OriginalSmtpSettings = {
                    HostName : SmtpSettings.HostName,
                    Enabled  : SmtpSettings.Enabled,
                    Host     : SmtpSettings.Transport.Host,
                    Port     : SmtpSettings.Transport.Port,
                    From     : SmtpSettings.Options.From,
                    User     : SmtpSettings.Transport.Auth.User,
                    Pass     : SmtpSettings.Transport.Auth.Pass,
                    Secure   : SmtpSettings.Transport.Secure
                }
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageSmtpSettings.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure SMTP Settings";
                        $scope.SmtpSettings = SmtpSettings;
                        $scope.OriginalSmtpSettings = {
                            HostName : SmtpSettings.HostName,
                            Enabled  : SmtpSettings.Enabled,
                            Host     : SmtpSettings.Transport.Host,
                            Port     : SmtpSettings.Transport.Port,
                            From     : SmtpSettings.Options.From,
                            User     : SmtpSettings.Transport.Auth.User,
                            Pass     : SmtpSettings.Transport.Auth.Pass,
                            Secure   : SmtpSettings.Transport.Secure
                        }
                        $scope.EnabledOptions = [{ option: 'YES' }, { option: 'NO' }];
                        $scope.HostNamePattern = /^[\w][\w ]{0,15}$/;
                        $scope.HostPattern = /^((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|((([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9]))$/;
                        $scope.PortPattern = /^[1-9][0-9]{0,4}$/;
                        $scope.FromEmailAddressPattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                        $scope.AuthUserPattern = /^[\x20-\x7F][\x20-\x7F]{0,32}$/;
                        $scope.AuthPassPattern = /^[\x20-\x7F][\x20-\x7F]{0,32}$/;
                        
                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "YES") {
                                $scope.SmtpSettings.Enabled = true;
                            } else {
                                $scope.SmtpSettings.Enabled = false;
                            }
                        }
                        
                        $scope.SetSecure = function (option) {
                            if (option == "YES") {
                                $scope.SmtpSettings.Transport.Secure = true;
                            } else {
                                $scope.SmtpSettings.Transport.Secure = false;
                            }
                        }
                        
                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/smtp");
                            
                            $http({
                                method: "put",
                                url: "/api/network/smtp",
                                data: $scope.SmtpSettings
                            }).success(function (data) {
                                    console.log('ConfigureSmtpSettings PUT success data=' + JSON.stringify(data));
                                });
                            $modalInstance.close();
                        };
                        
                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            SmtpSettings.HostName = OriginalSmtpSettings.HostName;
                            SmtpSettings.Enabled = OriginalSmtpSettings.Enabled;
                            SmtpSettings.Transport.Host = OriginalSmtpSettings.Host;
                            SmtpSettings.Transport.Port = OriginalSmtpSettings.Port;
                            SmtpSettings.Options.From = OriginalSmtpSettings.From;
                            SmtpSettings.Transport.Auth.User = OriginalSmtpSettings.User;
                            SmtpSettings.Transport.Auth.Pass = OriginalSmtpSettings.Pass;
                            SmtpSettings.Transport.Secure = OriginalSmtpSettings.Secure;
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function () {
                }, function () {
                    SmtpSettings.HostName = OriginalSmtpSettings.HostName;
                    SmtpSettings.Enabled = OriginalSmtpSettings.Enabled;
                    SmtpSettings.Transport.Host = OriginalSmtpSettings.Host;
                    SmtpSettings.Transport.Port = OriginalSmtpSettings.Port;
                    SmtpSettings.Options.From = OriginalSmtpSettings.From;
                    SmtpSettings.Transport.Auth.User = OriginalSmtpSettings.User;
                    SmtpSettings.Transport.Auth.Pass = OriginalSmtpSettings.Pass;
                    SmtpSettings.Transport.Secure = OriginalSmtpSettings.Secure;
                });
            };
            
            // Add a new SMTP Email
            //  /api/network/smtp
            $scope.AddSmtpEmail = function (SmtpSettings) {
                console.log("Inside AddSmtpEmail")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageSmtpEmail.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Add SMTP Email";
                        SmtpSettings.Options.To.splice(0, 0, { "Name": "", "Enabled": false, "Email": "" });// Add to front (more visible)
                        $scope.index = 0;
                        $scope.SmtpSettings = SmtpSettings;
                        $scope.EnabledOptions = [{ option: 'YES' }, { option: 'NO' }];
                        $scope.NamePattern = /^[\w][\w ]{0,15}$/;
                        $scope.EmailAddressPattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                        
                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "YES") {
                                $scope.SmtpSettings.Options.To[0].Enabled = true;
                            } else {
                                $scope.SmtpSettings.Options.To[0].Enabled = false;
                            }
                        }
                        
                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/smtp/");
                            
                            $http({
                                method: "put",
                                url: "/api/network/smtp",
                                data: $scope.SmtpSettings
                            }).success(function (data) {
                                    console.log('ConfigureSmtpEmail PUT success data=' + JSON.stringify(data));
                                });
                            $modalInstance.close();
                        };
                        
                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            SmtpSettings.Options.To.splice(0, 1);// Get rid of this, not wanted
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function () {
                }, function () {
                    SmtpSettings.Options.To.splice(0, 1);// Get rid of this, not wanted
                });
            };
            
            // Edit an existing SMTP Email
            //  /api/network/smtp
            $scope.ConfigureSmtpEmail = function (index,SmtpSettings) {
                console.log("Inside ConfigureSmtpEmail")
                var OriginalSmtpSettings = {
                    Name    : SmtpSettings.Options.To[index].Name,
                    Enabled : SmtpSettings.Options.To[index].Enabled,
                    Email   : SmtpSettings.Options.To[index].Email
                }
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageSmtpEmail.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure SMTP Email";
                        $scope.index = index;
                        $scope.SmtpSettings = SmtpSettings;

                        $scope.EnabledOptions = [{ option: 'YES' }, { option: 'NO' }];
                        $scope.NamePattern = /^[\w][\w ]{0,15}$/;
                        $scope.EmailAddressPattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                        
                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "YES") {
                                $scope.SmtpSettings.Options.To[index].Enabled = true;                                
                            } else {
                                $scope.SmtpSettings.Options.To[index].Enabled = false;
                            }
                        }
                        
                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/smtp/");

                            $http({
                                method: "put",
                                url: "/api/network/smtp",
                                data: $scope.SmtpSettings
                            }).success(function (data) {
                                    console.log('ConfigureSmtpEmail PUT success data=' + JSON.stringify(data));
                                });
                            $modalInstance.close();
                        };
                        
                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            SmtpSettings.Options.To[index].Name = OriginalSmtpSettings.Name;
                            SmtpSettings.Options.To[index].Enabled = OriginalSmtpSettings.Enabled;
                            SmtpSettings.Options.To[index].Email = OriginalSmtpSettings.Email;
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function () {
                }, function () {
                    SmtpSettings.Options.To[index].Name = OriginalSmtpSettings.Name;
                    SmtpSettings.Options.To[index].Enabled = OriginalSmtpSettings.Enabled;
                    SmtpSettings.Options.To[index].Email = OriginalSmtpSettings.Email;
                });
            };
            
            // Delete an existing SMTP Email
            //  /api/network/smtp
            $scope.DeleteSmtpEmail = function (index,SmtpSettings) {
                console.log("Inside DeleteSmtpEmail")
                SmtpSettings.Options.To.splice(index,1)
                $http({
                    method: "put",
                    url: "/api/network/smtp",
                    data: SmtpSettings
                })
                .success(function (data) {
                        console.log('DeleteSmtpEmail success - data=' + JSON.stringify(data));
                        SmtpSettings = data;
                    })
            };

            //#endregion Network - Email (SMTP)

            //----------------------------------------------------------
            // SNMP Server
            //#region Network - SNMP tab
            
            $scope.SnmpHostsArray = [];
            
            // Retreive array of SNMP Hosts
            //  /api/network/snmp/hosts
            $scope.GetSnmpHosts = function () {
                console.log("GetSnmpHosts called ...")
                $http({
                    method: "get",
                    url: "/api/network/snmp/hosts"
                })
                .success(function (data) {
                        console.log('GetSnmpHosts success - data=' + JSON.stringify(data));
                        $scope.SnmpHostsArray = data;
                        $scope.NumberOfSnmpHosts = data.length;
                    })
            }
            $scope.GetSnmpHosts();
            
            // Send test trap to SNMP Host
            //  /api/network/snmp/test
            $scope.SendTestTrap = function (currentSnmpHost) {
                console.log("Inside SendTestTrap")
                $http({
                    method: "put",
                    url: "/api/network/snmp/test",
                    data: currentSnmpHost
                })
                .success(function (data) {
                        console.log('SendTestTrap success - data=' + JSON.stringify(data));
                    })
            };
            
            // Add an SNMP Host
            //  /api/network/snmp/hosts
            $scope.AddSnmpHost = function (snmpHostsArray) {
                console.log("Inside AddSnmpHost")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/managesnmphost.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Add SNMP Host";
                        $scope.tempSnmpHost = {
                            HostName : "" , 
                            HostNamePattern: /^[\w]{1,16}$/,
                            Enabled : "YES" , 
                            IpAddress : "" , 
                            IpAddressPattern : /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,
                            Port : "162" , 
                            //PortPattern : new RegExp("^(6553[0-5]|655[0-2][0-9]\d|65[0-4](\d){2}|6[0-4](\d){3}|[1-5](\d){4}|[1-9](\d){0,3})$"), 
                            Community : "Public",
                            CommunityPattern : /^[a-zA-Z]{1,16}$/
                        };
                        
                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'YES' }, { option: 'NO' }];
                        
                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/snmp/hosts");
                            $http({
                                method: "put",
                                url: "/api/network/snmp/hosts",
                                data: $scope.tempSnmpHost
                            }).success(function (data) {
                                    //console.log('AddSnmpHost PUT success data=' + JSON.stringify(data));
                                    $modalInstance.close(data);
                                });
                        };
                        
                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    },
                });
                
                // Save the results from the modal to $scope data, so it will automatically update the UI
                modalInstance.result.then(function (SnmpHostsArray) {
                    $scope.SnmpHostsArray = SnmpHostsArray;
                }, function () {
                    console.log('Modal dismissed at: ' + new Date());
                });
            };
            
            // Edit an existing SNMP Host
            //  /api/network/snmp/hosts/:host
            $scope.ConfigureSnmpHost = function (currentSnmpHost) {
                console.log("Inside ConfigureSnmpHost")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/managesnmphost.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure SNMP Host";
                        $scope.tempSnmpHost = {
                            Id : currentSnmpHost.Id, 
                            HostName : currentSnmpHost.HostName, 
                            HostNamePattern: /^[\w]{1,16}$/,
                            Enabled : currentSnmpHost.Enabled, 
                            IpAddress : currentSnmpHost.IpAddress, 
                            IpAddressPattern : /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,
                            Port : currentSnmpHost.Port, 
                            Community : currentSnmpHost.Community,
                            CommunityPattern : /^[a-zA-Z]{1,16}$/
                        };
                        
                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'YES' }, { option: 'NO' }];
                        
                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            $scope.tempSnmpHost.Enabled = option
                        }
                        
                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/snmp/hosts/" + currentSnmpHost.Id);
                            $http({
                                method: "put",
                                url: "/api/network/snmp/hosts/" + currentSnmpHost.Id,
                                data: $scope.tempSnmpHost
                            }).success(function (data) {
                                    console.log('ConfigureSnmpHost PUT success data=' + JSON.stringify(data));
                                    currentSnmpHost.HostName = data.HostName;
                                    currentSnmpHost.Enabled = data.Enabled;
                                    currentSnmpHost.IpAddress = data.IpAddress;
                                    currentSnmpHost.Port = data.Port;
                                    currentSnmpHost.Community = data.Community;
                                });
                            $modalInstance.close();
                        };
                        
                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            
            // Delete a SNMP Host
            //  /api/network/snmp/hosts/delete
            $scope.DeleteSnmpHost = function (currentSnmpHost) {
                console.log("Inside DeleteSnmpHost")
                $http({
                    method: "put",
                    url: "/api/network/snmp/hosts/delete",
                    data: currentSnmpHost
                })
                .success(function (data) {
                        console.log('DeleteSnmpHost success - data=' + JSON.stringify(data));
                        $scope.SnmpHostsArray = data;
                    })
            };

            // Retreive the mib file
            //  /api/network/snmp/mibfile
            $scope.GetSnmpMibFile = function () {
                $http({
                    method: "get",
                    url: "/api/network/snmp/mibfile"
                }).
                success(function (data, status, headers, config) {
                    console.log("Inside GetSnmpMibFile - downloaded TASC-PEAK.MIB file!");
                    var anchor = angular.element('<a/>');
                    anchor.attr({
                        href: 'data:text/plain;charset=utf-8,' + data,
                        target: '_blank',
                        download: "TASC-PEAK.MIB"
                    })[0].click();
                }).
                error(function (data, status, headers, config) {
                        console.log("Error downloading TASC-PEAK.MIB file")
                    });
            }
            //#endregion Network - SNMP tab

            //#region Network - Web Server tab
            //----------------------------------------------------------
            // Web Server
            //#endregion Network - Web Server tab            

        }
    ])
;




