﻿var spawn = require('child_process').spawn
var PassThrough = require('stream').PassThrough;
var lame = require('lame');

var ps = null;

var audio = new PassThrough;
exports.AudioStream = audio;

var info = new PassThrough;
exports.AudioInfo = info;

exports.AudioStart = function (options, logger) {
    logger.info("Audio.AudioStart");
    options = options || {};
    
    if (ps == null) {
        ps = spawn('arecord', ['-f', 'dat']);
        logger.info('Started: arecord -f dat')
        
        if (options.mp3output === true) {
            var encoder = new lame.Encoder({
                channels: 2,
                bitDepth: 16,
                sampleRate: 44100
            });
            logger.info('Audio.AudioStart - Encoding as mp3output');
            
            ps.stdout.pipe(encoder);
            encoder.pipe(audio);
            ps.stderr.pipe(info);

        } else {
            logger.info('Audio.AudioStart - Encoding as non-mp3output');
            ps.stdout.pipe(audio);
            ps.stderr.pipe(info);
        }
    }
};

exports.AudioStop = function (logger) {
    logger.info("Audio.AudioStop");

    if (ps) {
        ps.kill();
        ps = null;
    }
};
